---
title: es6 模块化
date: 2020-09-12 04:57:07
tags:
---

- js 在出现初期，是没有模块化的概念的，只是单纯的作为一个脚本语言，实现一些简单的页面特效，操作 DOM 的功能，但是随着 js 的功能越来越完善，功能越来越多，js 代码的编写就变的非常难以维护，代码量大，不利于后期的管理，因此在 es6 的时候，才正式推出属于前端的模块化概念。

- es6 之前，有一些第三方的库，request.js(AMD) 可以实现模块化。

- nodejs 出现的时候，推出了模块化的标准(CMD)，通过 require 和 module.exports 实现模块的导入和导出，但是这种模块化的标准只能 Nodejs 使用，浏览器不能使用。

- es6 模块化代码，浏览器不能够直接识别，需要通过工具转换之后，才能让浏览器识别这些代码。

# 使用 webpack 帮助我们转换 ES6 的高级语法

 webpack 是基于 Nodejs 开发的一款打包工具，所以必须先安装 NodeJS 环境。

- webpack 的作用：1. 打包静态资源，如果不打包，浏览器就要挨个去请求加载 js 文件，css 文件，图片等，打包之后，webpack 帮你合并成一个 js 文件，一个 css 文件，这样一方面可以减少浏览器请求的次数，并且打包之后的文件经过压缩的文件，体积更小；2. 转换高级语法，比如 es6, es7, es8, es9 里面的高级语法，浏览器不识别。

- 安装 webpack

  - npm install webpack webpack-cli -g

- 执行打包命令
  - webpack ./main.js
