---
title: git
date: 2020-09-12 07:57:07
tags:
---

# 本地仓库 和 远程仓库

1. 本地仓库
    你从远程仓库(码云) 中 clone 下来的项目中，有一个 .git 隐藏文件，这个文件会自动记录当前 clone 下来的项目内容有没有变动，只要有变动，就会被 .git 记录下来；
    .git 还可以自动关联本地项目和远程仓库的项目；

# 仓库的本地操作

1. 只有 git push/pull 是在操作远程仓库，其余的命令 git status/log/commit/add 等，都是在操作本地仓库。
2. 常用命令
   git status: 查看本地仓库的状态；
   git add .: 每次写完一个模块，都要先执行该命令，将修改的代码提交到暂存区，此时不会生成版本记录，版本号；
   git commit -m "提交信息": 提交修改的代码到本地仓库，此时就会生成版本号，同时 .git 也会记录这个版本号，方便后期进行版本的回退；
   git log: 用来查看当前仓库中，都有哪些 commit 提交；
   git reset --hard 0739ae(版本号前几位): 切换 commit 版本；

# 仓库的远程操作

 当本地仓库中的某一个模块完成了，本地也 commit 提交代码了，接下来将 该模块 的最新代码提交到远程仓库，只要本地仓库生成了新的提交 commit，记得 往远程仓库上推送，让远程仓库的代码和本地的提交实时保持同步。

1. 推送命令
    git push
    git push git@gitee.com:gaohairui/poject.git
    git push origin master

# master 主分支

 作为写代码的程序员，平时写项目，不要直接在主分支 master 上修改代码，因为主分支 master 上的项目要保证是稳定的，最新的。

### 普通程序员如何操作

1. 先把远程项目克隆到本地(先配置 ssh，而且要成为项目的开发者)；
2. 创建子分支，开始写自己的功能；
    git checkout -b "分支名称" (创建并切换到当前分支)
    git checkout "分支名称" (切换分支的命令)
3. 子分支创建完毕，写代码，代码完成之后，需要 commit 提交，为当前的子分支，生成一条提交记录。此时主分支 master 是没有这个代码提交的；
4. 将本地子分支同步到远程子分支
    git push --set-upstream origin "子分支名称" (会自动在远程仓库上，创建一个子分支)
5. 子分支是最新的代码了，此时，需要将本地的 master 和 远程的主分支 master 都更新为最新代码，需要将子分支的最新代码，合并到主分支 master 上。
6. 先合并本地的子分支内容，到主分支，然后，再将本地的主分支，推送到远程主分支；
    git checkout master;
    git merge user;
    本地的 master 是最新的
    在 master 分支下，执行 git push
