---
title: vue-router
date: 2020-08-12 11:57:07
tags: vue
---

# 什么是 vue-router

 vue-router 就是一个前端的路由管理系统，负责监听路由，加载对应的组件。它是 vue 官方指定的路由管理系统，vue + vue-router + vuex (vue 全家桶的核心成员)。

# 单页面应用

 single-page application，简称 SPA。是 h5 之后非常流行的一种页面构建方式，整个应用只有一个 .html 文件，这个 .html 文件就是由各种组件组合而成的，传统的.html 单文件现在都变成了组件，login.html -> login.vue; regit.html -> regist.vue。由于整个网站只有一个大页面，要想实现不同组件的切换，就需要使用 vue-router 来加载不同组件。

# url 构成

- url 的构成：协议、域名、端口、路径、参数、哈希值(/user)
- '#' 号后面跟的就是哈希值
- http://www.baidu.com:443/upload/images/#/regist
- url 中的哈希值原本是给浏览器使用的，最初是能够让浏览器根据 hash 值，实现页面的锚点定位。所以这个 hash 值，仅仅在浏览器端使用，这个 hash 值/user 是不会传递到后端的。

# 前端路由和后端路由

 **前端路由**：通过不断的切换 hash 值，而 url 地址(协议、域名、端口、路径)是不变的，从而实现页面的切换。前端路由跟后端一点关系都没有，完全就是在利用 hash 找组件。
 **后端路由**：通过不断的切换 url 地址，从而实现页面的切换。

- 总结：当页面的 url 地址发生变化(协议、域名、端口、路径)，页面就要发生跳转，因为你使用了不同 url 地址，浏览器就会向服务器发送请求，这是后端路由。如果 url 地址没有变化，只是 hash 发生变化，浏览器是不会发送新的请求的，浏览器会根据 hash 值找到对应的组件，加载组件内容，浏览器是不会重新加载页面的，这就是前端路由。
