---
title: vuex
date: 2020-08-12 12:57:07
tags: vue
---

 它主要是集中管理数据，类似于一个公共的存储空间，可以为各个组件提供数据支持。它主要是解决非父子组件传值，父子组件传值还是使用 props 和\$emit 方式，或者使用 v-model 模式。

# 安装

 npm install vuex -S

# state 对象

 它就是用来保存数据的一个对象，原先数据是保存到组件的 data(){}中，现在放在公共存储空间 state 中。

### 1. 方式一

直接在模板中使用：{{this.$store.state}}

### 2. 方式二

使用 mapState

# mutations 对象

 mutations 它是真个 vuex 体系中，唯一能够修改数据的对象，组件修改数据交由 vuex 的 mutations 处理，主要是防止组件都直接修改数据，造成 vuex 数据维护混乱。

### 方式一

this.\$store.commit("changeAge", { type, name: 1 });

### 方式二

使用 mapMutation

# actions 和 mutations 的区别

 actions 可以执行异步操作，然后再修改数据；mutations 是同步修改数据；

1. 从开发工具上来看：mutation 是同步修改数据，浏览器插件 Vue 是可以实时捕获 state 中数据的最新状态；而 action 是异步修改数据，如果使用 mutation 来异步操作数据，就会造成 浏览器插件 Vue 是不可以实时捕获 state 中数据的最新状态；影响调试。但是从页面的数据变化上来看，使用 action 和 mutation 是没有影响的，页面中的数据，都会自动更新。
2. 从任务的角度来看：如果两个任务之间有先后顺序，mutation 也不能异步操作数据。

# getters

 可以实现对 state 中的元素数据进行加工处理，返回一个新的数据，通过 getters 处理数据，其他组件直接可以使用 mapGetters 将 getters 中生成新属性，映射到组件的 计算属性 中，组件不需要自己再单独处理了。
