---
title: 微信小程序
date: 2020-09-19 01:57:07
tags:
---

# 一、全局配置和页面配置

 页面配置的优先级比全局配置的优先级高。

### 全局配置

1. 导航条背景色、字体颜色、文本

```
"navigationBarBackgroundColor": "#00b26a",
"navigationBarTitleText": "小程序配置",
"navigationBarTextStyle": "white"
```

2. 下拉刷新

```
"backgroundTextStyle": "dark",
"backgroundColor": "#3387ff",
```

3. tabBar 的配置

```
"tabBar": {
  "backgroundColor": "#00b26a", // 背景色
  "color": "#fcfcfc", // 默认文字颜色
  "selectedColor": "#3387ff", // 被选中的文字颜色
  "list": [
    {
      "text": "首页",
      "pagePath": "pages/index/index"
    },
    {
      "text": "设置",
      "pagePath": "pages/settings/setting"
    },
    {
      "text": "我的",
      "pagePath": "pages/mine/mine"
    }
  ]
},
```

### 页面配置

 和 app.json 配置的属性一致。

# 二、数据的渲染

1. wx:if 和 hidden 的区别
2. wx:for-index 和 wx:for-item 的使用
3. 全局数据 globalData 和 私有数据 data 的使用

# 三、事件绑定及传参

 pages/event/event

1. bindtap 或 bind:tap，不传参数
2. bindtap 或 bind:tap，传参数，自定义属性 data-\*传参数，接收时使用 e.currentTarget.dataset
3. bindinput 输入框事件，e.detail.value 接受数据

# 四、css 样式的设置

1. rpx 适配单位，适配原理
2. 全局样式 app.wxss 和 局部样式 \*.wxss 的优先级，局部会覆盖全局
3. 选择器有固定要求，不支持 \* 通配符选择器

# 五、路由切换页面

 pages/settings/settings

1. 组件中使用 <navigator> 组件，点击即可实现跳转，就像 a 标签一样；
2. js 中也可以跳转页面，方便实现 js 内部的逻辑跳转；

# 六、wxs 文件的使用

 作用：可以在模板文件 wxml 中，实时调用一些函数，并得到最新结果，类似于 computed 计算属性。pages/calc/calc。

1. 新建 calc.wxs 文件，并向外暴露属性或方法；
2. 在模板文件中通过 <wxs></wxs> 组件引入 .wxs 文件；
3. 在组件中使用 模块 暴露的属性或方法；

# 七、动态设置 class 类名及 style 样式

 pages/classAndStyle/classAndStyle

1. class 是可以直接渲染数组的；

# 一、动态绑定 style 样式

1. 模板中只能写样式字符串，不能直接加载对象；

# 二、生命周期函数

1. 私有数据 data 中，声明页面模板中需要展示的数据，设置 data 中的数据时，使用 this.setData({})，因为 setData 可以渲染页面模板；
2. 私有数据，不需要在页面上显示的数据，比如定时器变量 timer，那这种私有数据，可以设置在 data:{} 同级的位置；

# 三、网络请求、下拉刷新、上拉加载更多

1. 页面配置 下拉刷新，上拉加载；
2. 封装异步请求 Promise 到工具包 utils 中；

# 四、图片 API 实现图片的上传

1. image 组件默认宽度 320px、高度 240px
2. wx.chooseImage()

# 五、动画 API 实现元素的动画效果

1. 过渡 transition；
2. CSS 帧动画 @keyframe；
3. 小程序的动画 API：如何实现重复动画；

# 六、富文本组件 rich-text

# 七、按钮的开放能力 open-type

# 八、自定义自组件
