---
title: 骨架屏
date: 2020-09-13 01:57:07
tags: 小程序
---

# 概念

 解决移动端(小程序)的首次加载时的白屏问题，也可以称为首屏优化方案。

# 何时用？

1. 首页
2. 其他页面
3. 页面中某一部分使用

# 如何设置骨架屏

1. 可以自己写样式，写标签。
2. 使用一些第三方库。(a. 库使用量多不多；b. 最近的提交时间；)
3. 让 UI 切骨架屏的图。(最直接)

# 微信小程序中配置骨架屏

1. 手动实现，将骨架屏页面单独封装成子组件来使用；
2. 借助于 vant-weapp 小程序 UI 框架实现骨架屏；
   在小程序中配置 vant-weapp：
   a. 在 小程序 根目录，执行 npm init -y 命令，初始化包文件 package.json;
   b. npm i @vant/weapp -S --production
   c. 勾选 "详情 - 本地设置 - 使用 npm 模块"
   d. 使用 微信开发者工具 构建 npm 包，"工具 - 构建 npm"
   e. 将 "app.json" 中的 "style:v2" 删除
   f. {
   "usingComponents": {
   "van-button": "@vant/weapp/button/index"
   },
   }
   注意：项目构建时，不要放在中文路径中。
3. 利用 "微信开发者工具" 自带的生成骨架屏的功能，为某一个页面自动生成骨架屏。
   a. 等 当前页面 所有的数据 加载完毕之后，在生成骨架屏代码；
   b. 骨架屏仅包括页面首屏中的可见区域，对于横向滚动的 swiper 等容器，超出屏幕的子元素将被忽略；
   c. 请勿修改自动生成的骨架屏的代码，当效果不理想时，建议调整相关配置，这样当页面变更时，仍可自动生成；
